#include "cmpcode.h"
#include "LZ77.h"
#include "encode_b.h"

int __stdcall getLong(FILE *fp);

extern "C" int APIENTRY DllMain(HINSTANCE hInst, DWORD dwReason, LPVOID lpRsv)
{
	return TRUE;
}

// t@CǂݍŁAÍĕʖۑ
// typeEncode	: [IN] ÍtOi0:Í̂݁A1:k̂݁A2:Íƈkj
// key			: [IN] ÍEL[
// multiplicand : [IN] key ̔搔
// add			: [IN] key ̉
// filenameSave	: [IN] ۑt@C
// filenameLoad	: [IN] ǂݍ݃t@C
// ߂l		F ۃtOiFALSEFs, TRUEFj
BOOL __stdcall ccEncodeFile(UINT typeEncode, UINT key, int multiplicand, int add, TCHAR *filenameSave, TCHAR *filenameLoad)
{
	BOOL	ret = FALSE;
	FILE	*fpW;
	
	if(_tfopen_s(&fpW, filenameSave, TEXT("wb"))){
		return FALSE;
	}
	DATA	data = {0};
	if(typeEncode > 0){
		Compress(&data, filenameLoad);
	}
	if(typeEncode == 0){
		FILE	*fpR;
		if(!(_tfopen_s(&fpR, filenameLoad, TEXT("rb")))){
			unsigned int	filesize1,filesize2;
			fpos_t			pos;
			fseek(fpR, 0, SEEK_END);
			fgetpos(fpR, &pos);
			rewind(fpR);
			filesize1 = (unsigned int) pos;
			if(filesize1 > 0){
				BYTE	*pData = new BYTE [filesize1];
				filesize2 = fread(pData, sizeof(BYTE), filesize1, fpR);
				EncodeB(key, multiplicand, add, pData, filesize2);
				fwrite(pData, sizeof(BYTE), filesize2, fpW);
				delete[] pData;
				ret = TRUE;
			}
			fclose(fpR);
		}
	}
	else if(data.buffer && typeEncode == 2){
		int pos2 = 3 * sizeof(DWORD);
		EncodeB(key, multiplicand, add, data.buffer + pos2, data.len - pos2);
		fwrite(data.buffer, sizeof(BYTE), data.len, fpW);
		ret = TRUE;
	}
	else if(data.buffer && typeEncode == 1){
		fwrite(data.buffer, sizeof(BYTE), data.len, fpW);
		ret = TRUE;
	}
	fclose(fpW);
	FREE(data.buffer);
	return ret;
}// ccEncodeFile

// Ít@CǂݍŁAf[^擾
// typeEncode	: [IN]  ÍtOi0:Í̂݁A1:k̂݁A2:Íƈkj
// key			: [IN]  ÍEL[
// multiplicand : [IN]  key ̔搔
// add			: [IN]  key ̉
// pData		: [OUT] 󂯎f[^
// size			: [IN]  󂯎f[^̃TCY
// filenameLoad	: [IN]  ǂݍ݃t@C
// ߂l		F ۃtOiFALSEFs, TRUEFj
BOOL __stdcall ccDecodeFile(UINT typeEncode, UINT key, int multiplicand, int add, BYTE *pData, int size, TCHAR *filenameLoad)
{
	BOOL	ret = FALSE;
	if(pData){
		FILE			*fpR;
		unsigned int	filesize1,filesize2;
		BYTE			*pData2 = NULL;
		if(_tfopen_s(&fpR, filenameLoad, TEXT("rb"))){
			return FALSE;
		}
		if(typeEncode == 0){
			filesize1 = fread(pData, sizeof(BYTE), size, fpR);
			if(filesize1 > 0){
				EncodeB(key, multiplicand, add, pData, filesize1);
				ret = TRUE;
			}
		}
		else if(typeEncode == 2){
			fpos_t	pos;
			fseek(fpR, 0, SEEK_END);
			fgetpos(fpR, &pos);
			rewind(fpR);
			filesize1 = (unsigned int) pos;
			pData2 = (BYTE*) malloc(filesize1);
			if(pData2){
				filesize2 = fread(pData2, sizeof(BYTE), filesize1, fpR);
				if(filesize2 > 0){
					int pos2 = 3 * sizeof(DWORD);
					EncodeB(key, multiplicand, add, &pData2[pos2], filesize2 - pos2);
					filesize1 = filesize2;
					ret = TRUE;
				}
			}
		}
		fclose(fpR);
		if(typeEncode == 1){
			ret = Decompress(pData, size, filenameLoad);
		}
		else if(typeEncode == 2 && pData2){
			ret = Decompress(pData, size, pData2, filesize1);
		}
		FREE(pData2);
	}
	return ret;
}// ccDecode_File

// t@CTCY擾
// typeEncode	: [IN]  ÍtOi0:Í̂݁A1:k̂݁A2:Íƈkj
// filenameLoad	: [IN]  t@C
int __stdcall ccGetFileSize(UINT typeEncode, TCHAR *filename)
{
	int filesize = 0;
	FILE	*fpR;
	if(_tfopen_s(&fpR, filename, TEXT("rb"))){
		return FALSE;
	}
	if(typeEncode == 0){	// ݂̃t@CTCY
		fpos_t			pos;
		fseek(fpR, 0, SEEK_END);
		fgetpos(fpR, &pos);
		rewind(fpR);
		filesize = (unsigned int) pos;
	}
	else{					// WJ̃t@CTCY
		filesize = getLong(fpR);
	}
	fclose(fpR);
	return filesize;
}// ccGetFileSize

// t@CkĂ邩H
// ߂l	: iFALSE:񈳏kATRUE:kj
BOOL __stdcall ccIsCompress(TCHAR *filename)
{
	BOOL	ret = FALSE;
	int		size,dic,code;
	FILE	*fpR;
	if(_tfopen_s(&fpR, filename, TEXT("rb"))){
		return ret;
	}
	size = getLong(fpR);
	dic  = getLong(fpR);
	code = getLong(fpR);
	fclose(fpR);
	if(dic == 12 && code == 4){
		ret = TRUE;
	}
	return ret;
}// ccIsCompress

int __stdcall getLong(FILE *fp)
{
	BYTE buf[4];
	fread(buf, sizeof(BYTE), 4, fp);
	return (buf[0] << 24 | buf[1] << 16 | buf[2] << 8 | buf[3]);
}// getLong
